#ifndef _suart_h_
#define _suart_h_

#include <inttypes.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <util/delay.h>

#include "main.h"

// Baudrate 8,N,1
#define	BAUD		57600

//#define USE_SUART_RX
#define USE_SUART_TX
			// size must be in range 2 .. 256
#define STX_SIZE	16
#define	SRX_SIZE	16

// atMegax8
#define	STXD		SBIT( PORTB, PB1 )	// = OC1A
#define	STXD_DDR	SBIT( DDRB,  PB1 )

#define	SRXD_PIN	SBIT( PINB,  PB0 )	// = ICP1

extern void suart_init( void );

#ifdef USE_SUART_TX
#define	uputs(x)	uputs_((uint8_t*)(x))	// avoid char warning
extern void uputchar( uint8_t c );		// send byte
extern void uputs_( uint8_t *s );		// send string from SRAM

#define uputs_P(__s)	uputs_p(PSTR(__s))
extern void uputs_p( const char * pgm_s );	// send string from FLASH
#endif

#ifdef USE_SUART_RX
extern uint8_t kbhit( void );			// check incoming data
extern uint8_t ugetchar( void );		// get byte
#endif

#endif
